<template>
  <section v-if="personItem">
    <h1>Editar Persona</h1>

    <form @submit.prevent="updatePersonData">
      <div class="form-group">
        <label for="name">Nombre</label>
        <input type="text" id="name" v-model="person.name" class="form-control">
      </div>

      <div class="form-group">
        <label for="lastname">Apellido Paterno</label>
        <input type="text" id="lastname" v-model="person.lastname" class="form-control">
      </div>

      <div class="form-group">
        <label for="motherlastname">Apellido Materno</label>
        <input type="text" id="motherlastname" v-model="person.motherlastname" class="form-control">
      </div>

      <div class="form-group">
        <label for="gender">Género</label>
        <select type="text" id="gender" v-model="person.gender" class="form-control">
          <option value="M">Másculino</option>
          <option value="F">femenino</option>
        </select>
      </div>

      <div class="form-group">
        <label for="maritalstatus">Estado Civil</label>
        <select type="text" id="maritalstatus" v-model="person.maritalstatus" class="form-control">
          <option value="soltero">Soltero</option>
          <option value="Casado">Casado</option>
          <option value="Divorciado">Divorciado</option>
        </select>
      </div>

      <div class="form-group">
        <label for="birthdate">Fecha de Nacimiento</label>
        <input type="text" placeholder="año/mes/día" id="birthdate" v-model="person.birthdate" class="form-control">
      </div>

      <div class="form-group">
        <label for="placebirth">Lugar de Nacimiento</label>
        <input type="text" id="placebirth" v-model="person.placebirth" class="form-control">
      </div>

      <div class="form-group">
        <label for="typedocument">Tipo de Documento</label>
        <select type="text" id="typedocument" v-model="person.typedocument" class="form-control">
          <option value="DNI">DNI</option>
          <option value="PASAPORTE">Pasaporte</option>
        </select>
      </div>

      <div class="form-group">
        <label for="numberdocument">Número de Documento</label>
        <input type="text" id="numberdocument" v-model="person.numberdocument" class="form-control">
      </div>

      <button type="submit" class="btn btn-success">Guardar Persona</button>
    </form>
  </section>

</template>

<script>
import { mapActions, mapGetters } from 'vuex'

export default {
  name: 'UpdatePerson',
  data() {
    return {
      person: {
        id: '',
        name: '',
        lastname: '',
        motherlastname: '',
        gender: '',
        maritalstatus: '',
        birthdate: '',
        placebirth: '',
        typedocument: '',
        numberdocument: ''
      }
    }
  },
  methods: {
    ...mapActions('Person', ['updatePerson', 'getOnePerson']),
    async updatePersonData() {
      const data = {
        personId: this.$route.params.personId,
        person: this.person
      }

      await this.updatePerson(data)

      this.$router.push({ name: 'person.index' })
    }
  },
  computed: {
    ...mapGetters('Person', ['personItem'])
  },
  async mounted() {
    const persondId = this.$route.params.personId
    await this.getOnePerson(persondId)
    this.person = this.personItem
  }
}
</script>
